; define some functions that figure out what the beginning
; of the last interval is

; calculate a+(h*(n-1)) directly

(define (last-x1 a b n)
  (+ a (* (- n 1) (/ (- b a) n))))

; calculate a+(k*h) using a simple function, and
; pre-calculate k and h to pass to the function

(define (last-x2 a b n)
  (define (use-kh k h)
    (+ a (* k h )))
  (use-kh (- n 1) (/ (- b a) n)))

; calculate a+(k*h) using an anonymous function

(define (last-x3 a b n)
  ((lambda (k h) (+ a (* k h )))
   (- n 1) 
   (/ (- b a) n)))

; hide the use of the anonymous function by using let

(define (last-x4 a b n)
  (let ((h (/ (- b a) n))
        (k (- n 1)))
    (+ a (* k h ))))

(last-x1 0 1 10)
(last-x2 0 1 10)
(last-x3 0 1 10)
(last-x4 0 1 10)
